package io.xjar;

import java.io.IOException;
import java.io.InputStream;
import java.util.Enumeration;
import java.util.Set;
import java.io.OutputStream;
import org.apache.commons.compress.archivers.ArchiveEntry;
import org.apache.commons.compress.archivers.jar.JarArchiveEntry;
import io.loadkit.Resource;
import io.loadkit.Loaders;
import java.util.HashSet;
import org.apache.commons.compress.archivers.jar.JarArchiveOutputStream;

public class XInjector
{
    public static void inject(final JarArchiveOutputStream zos) throws IOException {
        final Set<String> directories = new HashSet<String>();
        final Enumeration<Resource> resources = Loaders.ant().load("io/xjar/**");
        while (resources.hasMoreElements()) {
            final Resource resource = resources.nextElement();
            final String name = resource.getName();
            final String directory = name.substring(0, name.lastIndexOf(47) + 1);
            if (directories.add(directory)) {
                final JarArchiveEntry xDirEntry = new JarArchiveEntry(directory);
                xDirEntry.setTime(System.currentTimeMillis());
                zos.putArchiveEntry((ArchiveEntry)xDirEntry);
                zos.closeArchiveEntry();
            }
            final JarArchiveEntry xJarEntry = new JarArchiveEntry(name);
            xJarEntry.setTime(System.currentTimeMillis());
            zos.putArchiveEntry((ArchiveEntry)xJarEntry);
            try (InputStream ris = resource.getInputStream()) {
                XKit.transfer(ris, (OutputStream)zos);
            }
            zos.closeArchiveEntry();
        }
    }
}
